//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  LimeGreen
#property indicator_color4  DarkOrange
#property indicator_color5  DarkOrange
#property indicator_color6  Yellow
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2

//
//
//
//
//

extern int    StoKPeriod = 144;
extern int    StoDPeriod =   9;
extern int    StoSlowing =   3;
extern int    SignalMode = MODE_EMA;
extern int    StoPrice   =  0;
extern int    LongPeriod = 50;
extern double Percent    = 95;

//
//
//
//
//

double sto[];
double stoda[];
double stodb[];
double sig[];
double leu[];
double led[];
double slope[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,leu);
   SetIndexBuffer(1,led);
   SetIndexBuffer(2,sto);
   SetIndexBuffer(3,stoda);
   SetIndexBuffer(4,stodb);
   SetIndexBuffer(5,sig);
   SetIndexBuffer(6,slope);
      IndicatorShortName("Stochastic ("+StoKPeriod+","+StoDPeriod+","+StoSlowing+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   if (slope[limit]==-1) CleanPoint(limit,stoda,stodb);
   for(i=limit; i>=0; i--) 
   {
      stoda[i] = EMPTY_VALUE;
      stodb[i] = EMPTY_VALUE;
      sto[i]   = iStochastic(NULL,0,StoKPeriod,StoDPeriod,StoSlowing,SignalMode,StoPrice,MODE_MAIN  ,i);
      sig[i]   = iStochastic(NULL,0,StoKPeriod,StoDPeriod,StoSlowing,SignalMode,StoPrice,MODE_SIGNAL,i);
            double hi = sto[ArrayMaximum(sto,LongPeriod,i)];
            double lo = sto[ArrayMinimum(sto,LongPeriod,i)];
            double rn = hi-lo;
      leu[i]   = lo+rn*Percent/100.0;
      led[i]   = hi-rn*Percent/100.0;
      slope[i] = slope[i+1];
            if (sto[i]>sto[i+1]) slope[i] =  1;
            if (sto[i]<sto[i+1]) slope[i] = -1;
            if (slope[i]==-1) PlotPoint(i,stoda,stodb,sto);
   }      
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

